#!/usr/bin/perl
# Converts a simple lsm file into an html table

## THIS CGI NEEDS TO BE RE-WRITTEN!!

use strict; # security -ea
use CGI;

my $query = new CGI;
my $lsmfile = $query->param("file");
my $lsm = 0;   # status flag: 1 while between Begin3 (or Begin4) and End
my $count = 0; # to detect "empty" files

# Do the opening html

# print "Content-type: text/html\n\n"; # or:
print $query->header;

&catfile ("html_top.html");

if (!($lsmfile =~ /^[A-Za-z0-9_-]+\/[A-Za-z0-9_-]+[.]lsm$/)) {
  # listdir is already sanitized above
  $lsmfile =~ s/[^A-Za-z0-9_\/.-]/<b>?<\/b>/g;
  print "<p>Invalid LSM file name: $lsmfile</p>\n";
  # Do the closing html
  &catfile ("html_bottom.html");
  exit (0);
} # error handling -ea

print "<p><A HREF=\"$lsmfile\">$lsmfile</A><BR><BR>\n";

# list the contents of the LSM file

if (!open(INF, "< " . $lsmfile)) { # no need to use sysopen, sanitized above
  # sysopen would be: sysopen(INF, $lsmfile, O_RDONLY)
  print "<p>No LSM file found for package <b>$lsmfile</b>.</p>\n";
  # Do the closing html
  &catfile ("html_bottom.html");
  exit (0);
} # error handling -ea

while (<INF>) {
    chomp;		# removes trailing \n
    # remove any html tags, so it displays properly
    s/&/&amp\;/g;
    s/\"/&quot\;/g;
    s/</&lt\;/g;
    s/>/&gt\;/g;
    s/\@/\&\#64\;/g; # spam protection -ea
    # should probably escape special stuff in &#123; style here
    # (take care to un-escape before including in HREF in that case)
    my $line = $_;

    # Remember that a properly-formed LSM file will contain a "Begin3"
    # or "Begin4" line, and an "End" line.  Look for these as the
    # beginning and ending of our LSM file.

    if ($line =~ /^Begin[34]/) {
	print "<TABLE BORDER=0 width='60%'>\n";
	print "<TR><TD ALIGN='center' VALIGN=top BGCOLOR=#eeeef8>Key</TD>\n";
	print "<TD ALIGN='center' VALIGN=top BGCOLOR=#eeeef8>Value\n";
	$lsm = 1;
    }
    elsif ($line =~ /^End/) {
	print "<TR><TD colspan=2>No key value pairs found!</TD></TR>\n"
		if ($count == 0);
	print "</TD></TR>\n";
	print "</TABLE>\n";
	$lsm = -1;
    }

    # inside the LSM file, new entries are of form "key:value".  A
    # value may be split across several lines.  If you have a
    # multi-line value, then start each continuation line with a space
    # or a tab.

    elsif ($line =~ /^\s/) { # if starts with whitespace
	# this is a continuation line - print it
	print "$line\n" if $lsm;
    }
    elsif ($lsm == 1) {
	print "</TD></TR>\n";

	$line .= ": (none)" if (!($line =~ /:/)); # -ea
	# this is a content line - split it and print the parts
	my ($key, $value) = split /:/, $line, 2;
	print "<TR><TH ALIGN=right VALIGN=top>$key</TH>\n";
	$value =~ s/^[ ]*//g; # strip leading  spaces -ea
	$value =~ s/[ ]*$//g; # strip trailing spaces -ea
	# Michael O'Brien's mod begins here
	# added more like that, and sanitizing -ea
        $value = "http://" . $value if $value =~ /^www/;
	# add / to domain-only URLs to make it pass the "linkability check" -ea
        $value = "$value/" if ($value =~ /^[fht]*tp[s]?:\/\/[^\/]+$/);
	$count++;
	if (($key =~ /-site/)
	# next is the "linkability check" -ea
        &&  ($value =~ /^[fht]*tp[s]?:\/\/[a-zA-Z0-9.-]+[:]?[0-9]*\/[a-zA-Z0-9~\/_.-]*$/)) {
		# was: key$ =~ /Primary-site/ (no value check)
		# should %nn escapes be allowed? All? And + escape?
	  	print "<TD ALIGN=left VALIGN=top><A HREF=\"$value\">$value</A>\n";
	      }
	else { 	print "<TD ALIGN=left VALIGN=top>$value\n";}

    } # ... else outside of LSM, ignore data
}

close ( INF );

if ($lsm == 1) {
	print "</TD></TR>\n";
	print "<TR><TD colspan=2>(no closing <b>End</b> found)</TD></TR>\n";

	print "<TR><TD colspan=2>No key value pairs found!</TD></TR>\n"
		if ($count == 0);

	print "</TABLE>\n";
	$lsm = -1;
}

if ($lsm == 0) {
	print "File contained neither <b>Begin3</b> nor <b>Begin4</b>!?\n";
	print "</TABLE>\n";
}


# Do the closing html

&catfile ("html_bottom.html");
exit (0);


# a sub to 'cat' the contents of a file.

sub catfile {
    if (!open (FILE, "< " . $_[0])) {
        printf "<!-- file not found: $_[0] -->\n";
        return;
    }
    print <FILE>;
    close (FILE);
}
