#!/usr/bin/perl
# Generate a table of the LSMs in a given "list" directory

## THIS CGI NEEDS TO BE RE-WRITTEN!!

use strict;
use CGI;

my $q = new CGI;
my $listdir = $q->param("dir");
my $count = 0;

# Do the opening html

print $q->header;
&cat( "html_top.html" );

# Read the contents of the dir

# Note that we can do a simple readdir, but I want to look only at the
# .lsm files.  So I can put a grep statement ahead of the readdir, so
# I only get .lsm files.

if (!($listdir =~ /^[A-Za-z0-9]+$/)) {
  print "<p>Illegal directory argument given!</p>\n";
  # Do the closing html
  &catfile ("html_bottom.html");
  exit (0);
} # error handling -ea

opendir( THISDIR, "$listdir" );
my @allfiles = sort grep /\.lsm$/, readdir( THISDIR );
closedir( THISDIR );

# Print the top of the table

print "<h2>LSM's for: &nbsp;&nbsp;<b>$listdir</b></h2>\n<p>\n";
print "<TABLE BORDER=1 width=\"80\%\">\n";
print "<TR>\n";
print "<TH width=\"20\%\">Title</TH>\n";
print "<TH>Version</TH>\n";
print "<TH>Entered-date</TH>\n";
print "<TH>Maintained-by</TH>\n";
print "<TH>Copying-policy</TH>\n";
print "</TR>\n";

# Scan through all lsm files:

my $lsmfile;

foreach $lsmfile ( @allfiles ) {
    &showlsm( $listdir . "/" . $lsmfile, $listdir );
    $count++;
}


print "<TR><TD COLSPAN=5 ALIGN=\"center\">";
print "No entries" if ($count < 1);
print "One entry" if ($count == 1);
print "$count entries" if ($count > 1);
print " found for: &nbsp;&nbsp;<b>$listdir</b></TD></TR>\n";

print "</p>\n</TABLE>\n";
&cat( "html_bottom.html" );
exit( 0 );


# A function to display the contents of a file.

sub cat {
    if (!open (FILE, "< " . $_[0])) {
        printf "<!-- file not found: $_[0] -->\n";
        return;
    }
    print <FILE>;
    close( FILE );
}


sub showlsm {
    # Split apart a single LSM file to show the name, version author, date

    my $lsmfile = $_[0];
    my $listdir = $_[1];

    my $line;
    my $key;
    my $value;
    my %lsmhash;


    if (!($lsmfile =~ /^[A-Za-z0-9_-]+\/[A-Za-z0-9_-]+[.]lsm$/)) {
        # listdir is already sanitized above
	$lsmfile =~ s/[^A-Za-z0-9_\/.-]/<b>?<\/b>/g;
        print "<TR><TD COLSPAN=5>Invalid LSM file name: $lsmfile</TD></TR>\n";
        return;
    } # error handling -ea

    # Set the URL to the LSM files

    # my $lsmpath = $listdir . "/" . $lsmfile;
    my $lsmpath = $lsmfile;

    if (!open(INF, "< " . $lsmfile)) {
        # no need to use sysopen, already sanitized above
        # sysopen would be: sysopen(INF, $lsmfile, O_RDONLY)
        print "<TR><TD COLSPAN=5>Unreadable LSM file: ";
	print "<b>$lsmfile</b></TD></TR>\n";
        return;
    } # error handling -ea

    while (<INF>) {
	chomp;		# removes trailing \n
	# Remove any html tags, so it displays properly
	s/&/&amp\;/g;
	s/\"/&quot\;/g;
	s/</&lt\;/g;
	s/>/&gt\;/g;
        s/\@/\&\#64\;/g; # spam protection -ea
	$line = $_;

	# Inside the LSM file, new entries are of form "key:value".  A
	# value may be split across several lines.  If you have a
	# multi-line value, then start each continuation line with a space
	# or a tab.

 	if ($line =~ /^\A/) {
            $line .= ": (none)" if (!($line =~ /:/)); # -ea
	    # this is a content line - split it and print the parts
	    ( $key, $value ) = split /:/, $line, 2;
            $value =~ s/^[ ]*//g; # strip leading  spaces -ea
            $value =~ s/[ ]*$//g; # strip trailing spaces -ea
	    $lsmhash{$key} = $value;
	} # ... else continuation line, ignored
    } # while

    close ( INF );
    # Now print the interesting parts of the hash

    $lsmhash{"Title"} = "no title"
	if (!exists $lsmhash{"Title"});
    $lsmhash{"Version"} = "n/a"
	if (!exists $lsmhash{"Version"});
    $lsmhash{"Entered-date"} = "unknown"
	if (!exists $lsmhash{"Entered-date"});
    $lsmhash{"Maintained-by"} = "<b>nobody - help wanted</b>"
	if (!exists $lsmhash{"Maintained-by"});
    $lsmhash{"Copying-policy"} = "unspecified"
	if (!exists $lsmhash{"Copying-policy"});

    print "<TR>\n";
    print "<TD>";
    print "<A HREF=\"lsm2html.cgi?file=$lsmpath\">";
    print   "" . $lsmhash{"Title"} . "</A></TD>\n";
    print "<TD>" . $lsmhash{"Version"} . "</TD>\n";
    print "<TD>" . $lsmhash{"Entered-date"} . "</TD>\n";
    print "<TD>" . $lsmhash{"Maintained-by"} . "</TD>\n";
    print "<TD>" . $lsmhash{"Copying-policy"} . "</TD>\n";
    print "</TR>\n";
}
